// /////////////////////////////////////////////////////////////////////////
// SystemC code automatically generated by hif2sc
// Part of HIFSuite - Version stable
// Site: www.hifsuite.com - Contact: hifsuite@edalab.it
//
// HIFSuite copyright: EDALab s.r.l. - Networked Embedded Systems
// Site: www.edalab.it - Contact: info@edalab.it
// /////////////////////////////////////////////////////////////////////////


#include "../inc/amba_apb_bus.hpp"



amba_apb_bus::amba_apb_bus( sc_core::sc_module_name name_ ) :
    sc_core::sc_module( name_ ),
    clk("clk"),
    apb_master_pclk("apb_master_pclk"),
    apb_master_presetn("apb_master_presetn"),
    apb_master_paddr("apb_master_paddr"),
    apb_master_psel1("apb_master_psel1"),
    apb_master_psel2("apb_master_psel2"),
    apb_master_psel3("apb_master_psel3"),
    apb_master_psel4("apb_master_psel4"),
    apb_master_psel5("apb_master_psel5"),
    apb_master_psel6("apb_master_psel6"),
    apb_master_psel7("apb_master_psel7"),
    apb_master_psel8("apb_master_psel8"),
    apb_master_penable("apb_master_penable"),
    apb_master_pwrite("apb_master_pwrite"),
    apb_master_pwdata("apb_master_pwdata"),
    apb_master_pready("apb_master_pready"),
    apb_master_prdata("apb_master_prdata"),
    apb_1_pclk("apb_1_pclk"),
    apb_1_presetn("apb_1_presetn"),
    apb_1_paddr("apb_1_paddr"),
    apb_1_psel("apb_1_psel"),
    apb_1_penable("apb_1_penable"),
    apb_1_pwrite("apb_1_pwrite"),
    apb_1_pwdata("apb_1_pwdata"),
    apb_1_pready("apb_1_pready"),
    apb_1_prdata("apb_1_prdata"),
    apb_2_pclk("apb_2_pclk"),
    apb_2_presetn("apb_2_presetn"),
    apb_2_paddr("apb_2_paddr"),
    apb_2_psel("apb_2_psel"),
    apb_2_penable("apb_2_penable"),
    apb_2_pwrite("apb_2_pwrite"),
    apb_2_pwdata("apb_2_pwdata"),
    apb_2_pready("apb_2_pready"),
    apb_2_prdata("apb_2_prdata"),
    apb_3_pclk("apb_3_pclk"),
    apb_3_presetn("apb_3_presetn"),
    apb_3_paddr("apb_3_paddr"),
    apb_3_psel("apb_3_psel"),
    apb_3_penable("apb_3_penable"),
    apb_3_pwrite("apb_3_pwrite"),
    apb_3_pwdata("apb_3_pwdata"),
    apb_3_pready("apb_3_pready"),
    apb_3_prdata("apb_3_prdata"),
    apb_4_pclk("apb_4_pclk"),
    apb_4_presetn("apb_4_presetn"),
    apb_4_paddr("apb_4_paddr"),
    apb_4_psel("apb_4_psel"),
    apb_4_penable("apb_4_penable"),
    apb_4_pwrite("apb_4_pwrite"),
    apb_4_pwdata("apb_4_pwdata"),
    apb_4_pready("apb_4_pready"),
    apb_4_prdata("apb_4_prdata"),
    apb_5_pclk("apb_5_pclk"),
    apb_5_presetn("apb_5_presetn"),
    apb_5_paddr("apb_5_paddr"),
    apb_5_psel("apb_5_psel"),
    apb_5_penable("apb_5_penable"),
    apb_5_pwrite("apb_5_pwrite"),
    apb_5_pwdata("apb_5_pwdata"),
    apb_5_pready("apb_5_pready"),
    apb_5_prdata("apb_5_prdata"),
    apb_6_pclk("apb_6_pclk"),
    apb_6_presetn("apb_6_presetn"),
    apb_6_paddr("apb_6_paddr"),
    apb_6_psel("apb_6_psel"),
    apb_6_penable("apb_6_penable"),
    apb_6_pwrite("apb_6_pwrite"),
    apb_6_pwdata("apb_6_pwdata"),
    apb_6_pready("apb_6_pready"),
    apb_6_prdata("apb_6_prdata"),
    apb_7_pclk("apb_7_pclk"),
    apb_7_presetn("apb_7_presetn"),
    apb_7_paddr("apb_7_paddr"),
    apb_7_psel("apb_7_psel"),
    apb_7_penable("apb_7_penable"),
    apb_7_pwrite("apb_7_pwrite"),
    apb_7_pwdata("apb_7_pwdata"),
    apb_7_pready("apb_7_pready"),
    apb_7_prdata("apb_7_prdata"),
    apb_8_pclk("apb_8_pclk"),
    apb_8_presetn("apb_8_presetn"),
    apb_8_paddr("apb_8_paddr"),
    apb_8_psel("apb_8_psel"),
    apb_8_penable("apb_8_penable"),
    apb_8_pwrite("apb_8_pwrite"),
    apb_8_pwdata("apb_8_pwdata"),
    apb_8_pready("apb_8_pready"),
    apb_8_prdata("apb_8_prdata"),
    clkSuphif_0("clkSuphif_0")
{
    apb_master_pclk.initialize( false );
    apb_master_pready.initialize( false );
    apb_master_prdata.initialize( 0UL );
    apb_1_pclk.initialize( false );
    apb_1_presetn.initialize( false );
    apb_1_paddr.initialize( 0UL );
    apb_1_psel.initialize( false );
    apb_1_penable.initialize( false );
    apb_1_pwrite.initialize( false );
    apb_1_pwdata.initialize( 0UL );
    apb_2_pclk.initialize( false );
    apb_2_presetn.initialize( false );
    apb_2_paddr.initialize( 0UL );
    apb_2_psel.initialize( false );
    apb_2_penable.initialize( false );
    apb_2_pwrite.initialize( false );
    apb_2_pwdata.initialize( 0UL );
    apb_3_pclk.initialize( false );
    apb_3_presetn.initialize( false );
    apb_3_paddr.initialize( 0UL );
    apb_3_psel.initialize( false );
    apb_3_penable.initialize( false );
    apb_3_pwrite.initialize( false );
    apb_3_pwdata.initialize( 0UL );
    apb_4_pclk.initialize( false );
    apb_4_presetn.initialize( false );
    apb_4_paddr.initialize( 0UL );
    apb_4_psel.initialize( false );
    apb_4_penable.initialize( false );
    apb_4_pwrite.initialize( false );
    apb_4_pwdata.initialize( 0UL );
    apb_5_pclk.initialize( false );
    apb_5_presetn.initialize( false );
    apb_5_paddr.initialize( 0UL );
    apb_5_psel.initialize( false );
    apb_5_penable.initialize( false );
    apb_5_pwrite.initialize( false );
    apb_5_pwdata.initialize( 0UL );
    apb_6_pclk.initialize( false );
    apb_6_presetn.initialize( false );
    apb_6_paddr.initialize( 0UL );
    apb_6_psel.initialize( false );
    apb_6_penable.initialize( false );
    apb_6_pwrite.initialize( false );
    apb_6_pwdata.initialize( 0UL );
    apb_7_pclk.initialize( false );
    apb_7_presetn.initialize( false );
    apb_7_paddr.initialize( 0UL );
    apb_7_psel.initialize( false );
    apb_7_penable.initialize( false );
    apb_7_pwrite.initialize( false );
    apb_7_pwdata.initialize( 0UL );
    apb_8_pclk.initialize( false );
    apb_8_presetn.initialize( false );
    apb_8_paddr.initialize( 0UL );
    apb_8_psel.initialize( false );
    apb_8_penable.initialize( false );
    apb_8_pwrite.initialize( false );
    apb_8_pwdata.initialize( 0UL );
    clkSuphif_0 = false;

    SC_METHOD( vhdl_process );
    sensitive << clk;

    SC_METHOD( UpdclkSuphif_0 );
    sensitive << clk;
}

amba_apb_bus::~amba_apb_bus()
{}

void amba_apb_bus::vhdl_process()
{
    apb_master_pclk = clk.read();
    apb_1_pclk = clk.read();
    apb_2_pclk = clk.read();
    apb_3_pclk = clk.read();
    apb_4_pclk = clk.read();
    apb_5_pclk = clk.read();
    apb_6_pclk = clk.read();
    apb_7_pclk = clk.read();
    apb_8_pclk = clk.read();
    if (clk.read() != clkSuphif_0.read() && clk.read() == true)
    {
        if (apb_master_psel1.read() == true)
        {
            apb_1_penable = apb_master_penable.read();
            apb_1_pwrite = apb_master_pwrite.read();
            apb_1_paddr = apb_master_paddr.read();
            apb_1_pwdata = apb_master_pwdata.read();
            apb_1_presetn = apb_master_presetn.read();
            apb_master_prdata = apb_1_prdata.read();
            apb_master_pready = apb_1_pready.read();
            apb_2_paddr = 0UL;
            apb_2_pwdata = 0UL;
            apb_2_penable = false;
            apb_2_pwrite = false;
            apb_2_presetn = false;
            apb_3_paddr = 0UL;
            apb_3_pwdata = 0UL;
            apb_3_penable = false;
            apb_3_pwrite = false;
            apb_3_presetn = false;
            apb_4_paddr = 0UL;
            apb_4_pwdata = 0UL;
            apb_4_penable = false;
            apb_4_pwrite = false;
            apb_4_presetn = false;
            apb_5_paddr = 0UL;
            apb_5_pwdata = 0UL;
            apb_5_penable = false;
            apb_5_pwrite = false;
            apb_5_presetn = false;
            apb_6_paddr = 0UL;
            apb_6_pwdata = 0UL;
            apb_6_penable = false;
            apb_6_pwrite = false;
            apb_6_presetn = false;
            apb_7_paddr = 0UL;
            apb_7_pwdata = 0UL;
            apb_7_penable = false;
            apb_7_pwrite = false;
            apb_7_presetn = false;
            apb_8_paddr = 0UL;
            apb_8_pwdata = 0UL;
            apb_8_penable = false;
            apb_8_pwrite = false;
            apb_8_presetn = false;
        }
        else if (apb_master_psel2.read() == true)
        {
            apb_2_penable = apb_master_penable.read();
            apb_2_pwrite = apb_master_pwrite.read();
            apb_2_paddr = apb_master_paddr.read();
            apb_2_pwdata = apb_master_pwdata.read();
            apb_2_presetn = apb_master_presetn.read();
            apb_master_prdata = apb_2_prdata.read();
            apb_master_pready = apb_2_pready.read();
            apb_1_paddr = 0UL;
            apb_1_pwdata = 0UL;
            apb_1_penable = false;
            apb_1_pwrite = false;
            apb_1_presetn = false;
            apb_3_paddr = 0UL;
            apb_3_pwdata = 0UL;
            apb_3_penable = false;
            apb_3_pwrite = false;
            apb_3_presetn = false;
            apb_4_paddr = 0UL;
            apb_4_pwdata = 0UL;
            apb_4_penable = false;
            apb_4_pwrite = false;
            apb_4_presetn = false;
            apb_5_paddr = 0UL;
            apb_5_pwdata = 0UL;
            apb_5_penable = false;
            apb_5_pwrite = false;
            apb_5_presetn = false;
            apb_6_paddr = 0UL;
            apb_6_pwdata = 0UL;
            apb_6_penable = false;
            apb_6_pwrite = false;
            apb_6_presetn = false;
            apb_7_paddr = 0UL;
            apb_7_pwdata = 0UL;
            apb_7_penable = false;
            apb_7_pwrite = false;
            apb_7_presetn = false;
            apb_8_paddr = 0UL;
            apb_8_pwdata = 0UL;
            apb_8_penable = false;
            apb_8_pwrite = false;
            apb_8_presetn = false;
        }
        else if (apb_master_psel3.read() == true)
        {
            apb_3_penable = apb_master_penable.read();
            apb_3_pwrite = apb_master_pwrite.read();
            apb_3_paddr = apb_master_paddr.read();
            apb_3_pwdata = apb_master_pwdata.read();
            apb_3_presetn = apb_master_presetn.read();
            apb_master_prdata = apb_3_prdata.read();
            apb_master_pready = apb_3_pready.read();
            apb_1_paddr = 0UL;
            apb_1_pwdata = 0UL;
            apb_1_penable = false;
            apb_1_pwrite = false;
            apb_1_presetn = false;
            apb_2_paddr = 0UL;
            apb_2_pwdata = 0UL;
            apb_2_penable = false;
            apb_2_pwrite = false;
            apb_2_presetn = false;
            apb_4_paddr = 0UL;
            apb_4_pwdata = 0UL;
            apb_4_penable = false;
            apb_4_pwrite = false;
            apb_4_presetn = false;
            apb_5_paddr = 0UL;
            apb_5_pwdata = 0UL;
            apb_5_penable = false;
            apb_5_pwrite = false;
            apb_5_presetn = false;
            apb_6_paddr = 0UL;
            apb_6_pwdata = 0UL;
            apb_6_penable = false;
            apb_6_pwrite = false;
            apb_6_presetn = false;
            apb_7_paddr = 0UL;
            apb_7_pwdata = 0UL;
            apb_7_penable = false;
            apb_7_pwrite = false;
            apb_7_presetn = false;
            apb_8_paddr = 0UL;
            apb_8_pwdata = 0UL;
            apb_8_penable = false;
            apb_8_pwrite = false;
            apb_8_presetn = false;
        }
        else if (apb_master_psel4.read() == true)
        {
            apb_4_penable = apb_master_penable.read();
            apb_4_pwrite = apb_master_pwrite.read();
            apb_4_paddr = apb_master_paddr.read();
            apb_4_pwdata = apb_master_pwdata.read();
            apb_4_presetn = apb_master_presetn.read();
            apb_master_prdata = apb_4_prdata.read();
            apb_master_pready = apb_4_pready.read();
            apb_1_paddr = 0UL;
            apb_1_pwdata = 0UL;
            apb_1_penable = false;
            apb_1_pwrite = false;
            apb_1_presetn = false;
            apb_2_paddr = 0UL;
            apb_2_pwdata = 0UL;
            apb_2_penable = false;
            apb_2_pwrite = false;
            apb_2_presetn = false;
            apb_3_paddr = 0UL;
            apb_3_pwdata = 0UL;
            apb_3_penable = false;
            apb_3_pwrite = false;
            apb_3_presetn = false;
            apb_5_paddr = 0UL;
            apb_5_pwdata = 0UL;
            apb_5_penable = false;
            apb_5_pwrite = false;
            apb_5_presetn = false;
            apb_6_paddr = 0UL;
            apb_6_pwdata = 0UL;
            apb_6_penable = false;
            apb_6_pwrite = false;
            apb_6_presetn = false;
            apb_7_paddr = 0UL;
            apb_7_pwdata = 0UL;
            apb_7_penable = false;
            apb_7_pwrite = false;
            apb_7_presetn = false;
            apb_8_paddr = 0UL;
            apb_8_pwdata = 0UL;
            apb_8_penable = false;
            apb_8_pwrite = false;
            apb_8_presetn = false;
        }
        else if (apb_master_psel5.read() == true)
        {
            apb_5_penable = apb_master_penable.read();
            apb_5_pwrite = apb_master_pwrite.read();
            apb_5_paddr = apb_master_paddr.read();
            apb_5_pwdata = apb_master_pwdata.read();
            apb_5_presetn = apb_master_presetn.read();
            apb_master_prdata = apb_5_prdata.read();
            apb_master_pready = apb_5_pready.read();
            apb_1_paddr = 0UL;
            apb_1_pwdata = 0UL;
            apb_1_penable = false;
            apb_1_pwrite = false;
            apb_1_presetn = false;
            apb_2_paddr = 0UL;
            apb_2_pwdata = 0UL;
            apb_2_penable = false;
            apb_2_pwrite = false;
            apb_2_presetn = false;
            apb_3_paddr = 0UL;
            apb_3_pwdata = 0UL;
            apb_3_penable = false;
            apb_3_pwrite = false;
            apb_3_presetn = false;
            apb_4_paddr = 0UL;
            apb_4_pwdata = 0UL;
            apb_4_penable = false;
            apb_4_pwrite = false;
            apb_4_presetn = false;
            apb_6_paddr = 0UL;
            apb_6_pwdata = 0UL;
            apb_6_penable = false;
            apb_6_pwrite = false;
            apb_6_presetn = false;
            apb_7_paddr = 0UL;
            apb_7_pwdata = 0UL;
            apb_7_penable = false;
            apb_7_pwrite = false;
            apb_7_presetn = false;
            apb_8_paddr = 0UL;
            apb_8_pwdata = 0UL;
            apb_8_penable = false;
            apb_8_pwrite = false;
            apb_8_presetn = false;
        }
        else if (apb_master_psel6.read() == true)
        {
            apb_6_penable = apb_master_penable.read();
            apb_6_pwrite = apb_master_pwrite.read();
            apb_6_paddr = apb_master_paddr.read();
            apb_6_pwdata = apb_master_pwdata.read();
            apb_6_presetn = apb_master_presetn.read();
            apb_master_prdata = apb_6_prdata.read();
            apb_master_pready = apb_6_pready.read();
            apb_1_paddr = 0UL;
            apb_1_pwdata = 0UL;
            apb_1_penable = false;
            apb_1_pwrite = false;
            apb_1_presetn = false;
            apb_2_paddr = 0UL;
            apb_2_pwdata = 0UL;
            apb_2_penable = false;
            apb_2_pwrite = false;
            apb_2_presetn = false;
            apb_3_paddr = 0UL;
            apb_3_pwdata = 0UL;
            apb_3_penable = false;
            apb_3_pwrite = false;
            apb_3_presetn = false;
            apb_4_paddr = 0UL;
            apb_4_pwdata = 0UL;
            apb_4_penable = false;
            apb_4_pwrite = false;
            apb_4_presetn = false;
            apb_5_paddr = 0UL;
            apb_5_pwdata = 0UL;
            apb_5_penable = false;
            apb_5_pwrite = false;
            apb_5_presetn = false;
            apb_7_paddr = 0UL;
            apb_7_pwdata = 0UL;
            apb_7_penable = false;
            apb_7_pwrite = false;
            apb_7_presetn = false;
            apb_8_paddr = 0UL;
            apb_8_pwdata = 0UL;
            apb_8_penable = false;
            apb_8_pwrite = false;
            apb_8_presetn = false;
        }
        else if (apb_master_psel7.read() == true)
        {
            apb_7_penable = apb_master_penable.read();
            apb_7_pwrite = apb_master_pwrite.read();
            apb_7_paddr = apb_master_paddr.read();
            apb_7_pwdata = apb_master_pwdata.read();
            apb_7_presetn = apb_master_presetn.read();
            apb_master_prdata = apb_7_prdata.read();
            apb_master_pready = apb_7_pready.read();
            apb_1_paddr = 0UL;
            apb_1_pwdata = 0UL;
            apb_1_penable = false;
            apb_1_pwrite = false;
            apb_1_presetn = false;
            apb_2_paddr = 0UL;
            apb_2_pwdata = 0UL;
            apb_2_penable = false;
            apb_2_pwrite = false;
            apb_2_presetn = false;
            apb_3_paddr = 0UL;
            apb_3_pwdata = 0UL;
            apb_3_penable = false;
            apb_3_pwrite = false;
            apb_3_presetn = false;
            apb_4_paddr = 0UL;
            apb_4_pwdata = 0UL;
            apb_4_penable = false;
            apb_4_pwrite = false;
            apb_4_presetn = false;
            apb_5_paddr = 0UL;
            apb_5_pwdata = 0UL;
            apb_5_penable = false;
            apb_5_pwrite = false;
            apb_5_presetn = false;
            apb_6_paddr = 0UL;
            apb_6_pwdata = 0UL;
            apb_6_penable = false;
            apb_6_pwrite = false;
            apb_6_presetn = false;
            apb_8_paddr = 0UL;
            apb_8_pwdata = 0UL;
            apb_8_penable = false;
            apb_8_pwrite = false;
            apb_8_presetn = false;
        }
        else if (apb_master_psel8.read() == true)
        {
            apb_8_penable = apb_master_penable.read();
            apb_8_pwrite = apb_master_pwrite.read();
            apb_8_paddr = apb_master_paddr.read();
            apb_8_pwdata = apb_master_pwdata.read();
            apb_8_presetn = apb_master_presetn.read();
            apb_master_prdata = apb_8_prdata.read();
            apb_master_pready = apb_8_pready.read();
            apb_1_paddr = 0UL;
            apb_1_pwdata = 0UL;
            apb_1_penable = false;
            apb_1_pwrite = false;
            apb_1_presetn = false;
            apb_2_paddr = 0UL;
            apb_2_pwdata = 0UL;
            apb_2_penable = false;
            apb_2_pwrite = false;
            apb_2_presetn = false;
            apb_3_paddr = 0UL;
            apb_3_pwdata = 0UL;
            apb_3_penable = false;
            apb_3_pwrite = false;
            apb_3_presetn = false;
            apb_4_paddr = 0UL;
            apb_4_pwdata = 0UL;
            apb_4_penable = false;
            apb_4_pwrite = false;
            apb_4_presetn = false;
            apb_5_paddr = 0UL;
            apb_5_pwdata = 0UL;
            apb_5_penable = false;
            apb_5_pwrite = false;
            apb_5_presetn = false;
            apb_6_paddr = 0UL;
            apb_6_pwdata = 0UL;
            apb_6_penable = false;
            apb_6_pwrite = false;
            apb_6_presetn = false;
            apb_7_paddr = 0UL;
            apb_7_pwdata = 0UL;
            apb_7_penable = false;
            apb_7_pwrite = false;
            apb_7_presetn = false;
        }
        apb_1_psel = apb_master_psel1.read();
        apb_2_psel = apb_master_psel2.read();
        apb_3_psel = apb_master_psel3.read();
        apb_4_psel = apb_master_psel4.read();
        apb_5_psel = apb_master_psel5.read();
        apb_6_psel = apb_master_psel6.read();
        apb_7_psel = apb_master_psel7.read();
        apb_8_psel = apb_master_psel8.read();
    }
}

void amba_apb_bus::UpdclkSuphif_0()
{
    clkSuphif_0 = clk.read();
}



